#include "types.h"
#include "bitmap.h"
#include "xmem.h"
#include <string.h>

bitmap_type
new_bitmap (dimensions_type d)
{
  bitmap_type answer;
  unsigned size = DIMENSIONS_WIDTH (d) * DIMENSIONS_HEIGHT (d);

  BITMAP_DIMENSIONS (answer) = d;
  BITMAP_PLANES (answer) = 1;
  XCALLOC (BITMAP_BITS (answer), size);

  return answer;
}


void
free_bitmap (bitmap_type *b)
{
  if (BITMAP_BITS (*b) != NULL)
    free (BITMAP_BITS (*b));
}


