#ifndef BITMAP_H
#define BITMAP_H

#include "types.h"
#include <stdio.h>

typedef struct
{
  dimensions_type dimensions;
  unsigned char *bitmap;
  unsigned int np;
} bitmap_type;

#define BITMAP_DIMENSIONS(b)  ((b).dimensions)
#define BITMAP_PLANES(b)  ((b).np)
#define BITMAP_BITS(b)  ((b).bitmap)
#define BITMAP_WIDTH(b)  DIMENSIONS_WIDTH (BITMAP_DIMENSIONS (b))
#define BITMAP_HEIGHT(b)  DIMENSIONS_HEIGHT (BITMAP_DIMENSIONS (b))
#define BITMAP_PIXEL(b, row, col)					\
  ((BITMAP_BITS (b) + (row) * BITMAP_PLANES (b) * BITMAP_WIDTH (b)	\
        + (col) * BITMAP_PLANES(b)))
#define BITMAP_VALID_PIXEL(b, row, col)					\
   	((row) < BITMAP_HEIGHT (b) && (col) < BITMAP_WIDTH (b))

extern bitmap_type new_bitmap (dimensions_type);
extern void free_bitmap (bitmap_type *);

#endif 
