#ifndef FIT_H
#define FIT_H

#include "types.h"
#include "pxl-outline.h"
#include "spline.h"

typedef struct
{
  real align_threshold;
  color_type *bgColor;

  unsigned color_count;

  real corner_always_threshold;

  unsigned corner_surround;

  real corner_threshold;
  real error_threshold;

  unsigned filter_alternative_surround;

  real filter_epsilon;

  unsigned filter_iteration_count;

  real filter_percent;

  unsigned filter_secondary_surround;
  unsigned filter_surround;

  real line_reversion_threshold;
  real line_threshold;
  bool remove_adj_corners;
  real reparameterize_improvement;
  real reparameterize_threshold;
  real subdivide_search;

  unsigned subdivide_surround;

  real subdivide_threshold;

  unsigned tangent_surround;

} fitting_opts_type;





extern spline_list_array_type fitted_splines
  (pixel_outline_list_type, fitting_opts_type *);


extern fitting_opts_type new_fitting_opts (void);



#endif 

