#include "input.h"
#include "input-bmp.h"
#include <string.h>

#define STREQ(s1, s2) (strcmp (s1, s2) == 0)

struct input_format_entry {
  input_read reader;
  const char * name;
};

static struct input_format_entry input_formats[] = {
  { ReadBMP, "bmp" },
  {NULL, NULL}
};

input_read
input_get_handler_by_suffix (string suffix)
{
  struct input_format_entry * format;
  for (format = input_formats ; format->name; format++)
    {
      if (STREQ (suffix, format->name))
	{
	  return format->reader;
	}
    }
  return NULL;
}

