#include "input.h"
#include "image-header.h"
#include "fit.h"
#include "output.h"
#include "pxl-outline.h"
#include "xmem.h"
 
#include <string.h>
#include <assert.h>

static input_read input_reader = NULL;
static output_write output_writer = NULL;

static fitting_opts_type fitting_opts;

int
main (int argc, char * argv[])
{
  image_header_type image_header;
  char * input_name, * output_name;
  pixel_outline_list_type pixels;
  spline_list_array_type splines;
  bitmap_type bitmap;
  FILE *output_file;
 
  int i;

  fitting_opts = new_fitting_opts ();

  input_name=argv[1];
  printf("%s\n", input_name); 
   
  output_name=argv[2];
  printf("%s\n", output_name); 

  input_reader = input_get_handler_by_suffix("bmp");
  output_writer = output_get_handler("vec");
  
  output_file = fopen(output_name, "w");
  
  bitmap = (*input_reader) (input_name);


  image_header.width = DIMENSIONS_WIDTH (bitmap.dimensions);
  image_header.height = DIMENSIONS_HEIGHT (bitmap.dimensions);

  pixels = find_outline_pixels (bitmap);
  splines = fitted_splines (pixels, &fitting_opts);

  output_writer (output_file, output_name, 0, 0, image_header.width, image_header.height, splines);
  
  fclose (output_file);

  free_spline_list_array (&splines); 
  free_pixel_outline_list (&pixels);
  free_bitmap (&bitmap);

  return 0;
}
