#ifndef MESSAGE_H
#define MESSAGE_H
#include "types.h"
#include <stdio.h>
#include <stdlib.h>

#define FATAL_PERROR(s) do { perror (s); exit (errno); } while (0)
#define START_FATAL() do { fputs ("fatal: ", stderr); 
#define END_FATAL() fputs (".\n", stderr); exit (1); } while (0)
#define FATAL(s)							\
  START_FATAL (); fprintf (stderr, "%s", s); END_FATAL ()
#define FATAL1(s, e1)							\
  START_FATAL (); fprintf (stderr, s, e1); END_FATAL ()
#define FATAL2(s, e1, e2)						\
  START_FATAL (); fprintf (stderr, s, e1, e2); END_FATAL ()
#define FATAL3(s, e1, e2, e3)						\
  START_FATAL (); fprintf (stderr, s, e1, e2, e3); END_FATAL ()
#define FATAL4(s, e1, e2, e3, e4)					\
  START_FATAL (); fprintf (stderr, s, e1, e2, e3, e4); END_FATAL ()
#define START_WARNING() do { fputs ("warning: ", stderr); 
#define END_WARNING() fputs (".\n", stderr); } while (0)
#define WARNING(s)							\
  START_WARNING (); fprintf (stderr, "%s", s); END_WARNING ()
#define WARNING1(s, e1)							\
  START_WARNING (); fprintf (stderr, s, e1); END_WARNING ()
#define WARNING2(s, e1, e2)						\
  START_WARNING (); fprintf (stderr, s, e1, e2); END_WARNING ()
#define WARNING3(s, e1, e2, e3)						\
  START_WARNING (); fprintf (stderr, s, e1, e2, e3); END_WARNING ()
#define WARNING4(s, e1, e2, e3, e4)					\
  START_WARNING (); fprintf (stderr, s, e1, e2, e3, e4); END_WARNING ()

#endif 

