#include "spline.h"
#include "output-vec.h"


static void
out_splines (FILE * file, spline_list_array_type shape)
{
  unsigned this_list;
  
  for (this_list = 0; this_list < SPLINE_LIST_ARRAY_LENGTH (shape);
       this_list++)
    {
      unsigned int i;
      spline_list_type list = SPLINE_LIST_ARRAY_ELT (shape, this_list);
      spline_type first = SPLINE_LIST_ELT (list, 0);
      
      
      for (i = 0; i < SPLINE_LIST_LENGTH (list); i++)
	{
	  
	  spline_type s = SPLINE_LIST_ELT (list, i);
	  
	  if (SPLINE_DEGREE (s) == LINEARTYPE) {
	    fprintf(file, "L C %f %f %f %f %d\n",
		    START_POINT(s).x, 
		    START_POINT(s).y,
		    END_POINT(s).x, 
		    END_POINT(s).y,
		    0);
	  }
	  else {
	    /*	   
	    fprintf(file, "A C %f %f %f %f %f %d\n",
		    , 
		    ,
		    ,
		    , 
		    ,
		    0);
	    */
	  }
	}
      
      
    }
}



int output_vec_writer(FILE* file, string name,
		     int llx, int lly, int urx, int ury,
		     spline_list_array_type shape)
{

  printf("%d\n%d\n%d\n%d\n", llx, lly, urx, ury);
  
  
  fprintf(file, "%VEC-1.0 %d %d\n", urx - llx, ury - lly);

  out_splines(file, shape);

  return 0;
}

/* version 0.22 */
