#include "output.h"
#include "output-vec.h"
#include <string.h>

struct output_format_entry {
    const char * name;
    const char * descr;
    output_write writer;
};


static struct output_format_entry output_formats[] = {
    {"vec",     "Vecteur",                      output_vec_writer},
    {NULL,	NULL}
};

output_write output_get_handler(string name)
{
    struct output_format_entry *entry;

    for (entry = output_formats; entry->name; entry++)
    {
	if (strcmp(name, entry->name) == 0)
	    break;
    }

    return entry->writer;
}

