#ifndef PXL_OUTLINE_H
#define PXL_OUTLINE_H

#include "bitmap.h"
#include "types.h"
#include "color.h"


typedef struct
{
  coordinate_type *data;
  unsigned length;
  bool clockwise;
  color_type color;
} pixel_outline_type;

#define O_COORDINATE(p_o, n) ((p_o).data[n])
#define O_LENGTH(p_o) ((p_o).length)
#define O_CLOCKWISE(p_o) ((p_o).clockwise)
#define O_NEXT(p_o, n) (((n) + 1) % O_LENGTH (p_o))
#define O_PREV(p_o, n) ((n) == 0				\
                         ? O_LENGTH (p_o) - 1			\
                         : (n) - 1)


typedef struct
{
  pixel_outline_type *data;
  unsigned length;
} pixel_outline_list_type;

#define O_LIST_OUTLINE(p_o_l, n) ((p_o_l).data[n])
#define O_LIST_LENGTH(p_o_l) ((p_o_l).length)


extern pixel_outline_list_type find_outline_pixels (bitmap_type);
extern void free_pixel_outline_list (pixel_outline_list_type *);


#endif
