
#include <stdio.h>

#define MAX_STR 256
#define FATAL( x ) { fprintf( stderr, x ); exit( 1 );}

FILE *outDXF;
FILE *inVec;

int exiting;

double x1, y1, x2, y2;
double rad;
double width;
double startAng, endAng;
double xsize, ysize;

char continuous;
char title[256];


int main( int argc, char *argv[] );
int skipToEOL( void );
void storeStrLine( void *place );
void interpVec(void );




int
main( int argc, char *argv[] )
{


    if ( (inVec = fopen( argv[1], "r" ) ) == 0 )
      {
			fprintf( stderr, "Impossible d'ouvrir %s en input\n", argv[1]);
			exit( 1 );
      }

    if ( (outDXF = fopen( argv[2], "w" ) ) == 0 )
      {
			fprintf( stderr, "Impossible d'ouvrir %s en output\n", argv[2]);
			exit( 1 );
      }


    fscanf( inVec, "%s", title );


    if ( strcmp( title, "%VEC-1.0") != 0 )
      {
			fprintf( stderr, "Mauvais Header: |%s|\n", title );
			exit( 1 );
      }

    fscanf( inVec, "%lf %lf", &xsize, &ysize );
    fprintf (outDXF,"0\nSECTION\n2\nHEADER\n0\nENDSEC\n0\nSECTION\n2\nTABLES\n0\nTABLE\n2\nVPORT\n70\n1\n0\nVPORT\n2\n*ACTIVE\n70\n0\n10\n0.0\n20\n0.0\n11\n1.0\n21\n1.0\n12\n%lf\n22\n%lf\n13\n0.0\n23\n0.0\n14\n10.0\n24\n10.0\n15\n10.0\n25\n10.0\n16\n0.0\n26\n0.0\n36\n1.0\n17\n0.0\n27\n0.0\n37\n0.0\n40\n297.0\n41\n1.0\n42\n50.0\n43\n0.0\n44\n0.0\n50\n0.0\n51\n0.0\n71\n0\n72\n100\n73\n1\n74\n3\n75\n0\n76\n0\n77\n0\n78\n0\n0\nENDTAB\n0\nENDSEC\n0\nSECTION\n2\nBLOCKS\n0\nENDSEC\n0\nSECTION\n2\nENTITIES\n",xsize/2,ysize/2);


    interpVec();

    fclose( inVec );
    fclose( outDXF );
    exit (0);

}


int
skipToEOL( void )
{
  int c;

    while ( 1 )
    	{
			c = fgetc( inVec );
			if ( c == '\n' )
			  return 0;
			if ( c == -1 )
				{
				    exiting = 1;
				    return -1;
				}
	    }
}


void
storeStrLine( void *place )
{
  int i, c;

  char *p = place;

  while ( ( c = fgetc( inVec ) ) == ' ' );
  ungetc( c, inVec );

  for ( i = 0; i < MAX_STR; i++ )
    {
      c = fgetc( inVec );
      if ( c == '\r' )
		continue;
      if ( c == '\n' )
		{
		  ungetc( c, inVec );
		  *p++ = 0;
		  return;
		}
      if ( c == EOF )
        {
		  FATAL( "Probleme EOF\n" );
        }

      *p++ = c;
    }
  skipToEOL();
}


void
interpVec()
{

	int c;
	double rad;
       	double startAng, endAng;
	double x1, y1, x2, y2, fontheight, fontwidthFactor, width, orient;
	char	 *text, *txtptr, *tmpstr;
	char   string[ MAX_STR ];
	int name=16;

    while ( !exiting )
    {
      if (( c = getc( inVec )) == EOF )
		{
		  exiting = 1;
		  fprintf(outDXF,"0\nENDSEC\n0\nEOF\n");
		  break;
		}

      switch ( c )
	{
	case '#':
	  break;

	case 'L':  /* Line */
	  fscanf( inVec, " %c %lf %lf %lf %lf %lf", &continuous, &x1, &y1, &x2, &y2, &width );

	  if (continuous == 'C')
	    {
	      fprintf(outDXF,"0\nLINE\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n30\n0.0\n11\n%lf\n21\n%lf\n31\n0.0\n",name++,x1,y1,x2,y2);
	    }

	  else
	    {
	      fprintf(outDXF,"0\nLINE\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n30\n0.0\n11\n%lf\n21\n%lf\n31\n0.0\n",name++,x1,y1,x2,y2);
	    }
	  break;

	case 'C':  /* Circle */
	  fscanf( inVec, " %c %lf %lf %lf %lf", &continuous, &x1, &y1, &rad, &width );

	  if (continuous == 'C')
	    {
	      fprintf(outDXF,"0\nCIRCLE\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n30\n0.0\n40\n%lf\n",name++,x1,y1,rad);
	    }

	  else
	    {
	      fprintf(outDXF,"0\nCIRCLE\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n30\n0.0\n40\n%lf\n",name++,x1,y1,rad);
	    }
	  break;

	case 'T':  /* Text */

	  fscanf( inVec, "%lf%lf%lf%lf%lf%lf%lf%lf", &x1, &y1, &x2, &y2, &orient, &fontheight, &fontwidthFactor, &width );

	  storeStrLine( string );
	  *tmpstr = strdup( string );
	  *text = strchr( string, '%');
	  text++;
 

	  fprintf(outDXF,"0\nTEXT\n5\n%x\n8\n0.0\n10\n%lf\n20\n%lf\n30\n0.0\n40\n%lf\n50\n%lf\n1\n%s\n",name++,x1,y1,fontheight,-orient,text);
	break;

	case 'A':
	  fscanf( inVec, " %c %lf %lf %lf %lf %lf %lf", &continuous, &x1, &y1, &rad, &startAng, &endAng, &width );

	  if (continuous == 'C')
	    {
	      fprintf(outDXF,"0\nARC\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n40\n%lf\n50\n%lf\n51\n%lf\n",name++,x1,y1,rad,startAng,endAng);
	    }

	  else
	    {
	      fprintf(outDXF,"0\nARC\n5\n%x\n8\n0\n10\n%lf\n20\n%lf\n40\n%lf\n50\n%lf\n51\n%lf\n",name++,x1,y1,rad,startAng,endAng);
	    }
	  break;

	default:
	  break;
	}
      skipToEOL();
    }
}
