#ifndef VECTOR_H
#define VECTOR_H

#include "types.h"


typedef struct
{
  real dx, dy;
} vector_type;


extern vector_type make_vector (const real_coordinate_type);
extern real_coordinate_type vector_to_point (const vector_type);
extern real magnitude (const vector_type);
extern vector_type normalize (const vector_type);

extern vector_type Vadd (const vector_type, const vector_type);
extern real Vdot (const vector_type, const vector_type);
extern vector_type Vmult_scalar (const vector_type, const real);
extern real Vangle (const vector_type in, const vector_type out);


#define Padd_vector Vadd_point
extern real_coordinate_type Vadd_point
  (const real_coordinate_type, const vector_type);

#define Psubtract_vector Vsubtract_point
extern real_coordinate_type Vsubtract_point
  (const real_coordinate_type, const vector_type);

#define IPadd_vector Vadd_int_point
extern coordinate_type Vadd_int_point
  (const coordinate_type, const vector_type);

extern vector_type Vabs (const vector_type);
extern vector_type Psubtract
  (const real_coordinate_type, const real_coordinate_type);

extern real_coordinate_type Padd (const real_coordinate_type,
                                  const real_coordinate_type);
extern real_coordinate_type Pmult_scalar (const real_coordinate_type, const real);

extern vector_type IPsubtract
  (const coordinate_type, const coordinate_type);
extern coordinate_type IPsubtractP
  (const coordinate_type, const coordinate_type);
extern coordinate_type IPadd
  (const coordinate_type, const coordinate_type);
extern coordinate_type IPmult_scalar (const coordinate_type, const int);
extern real_coordinate_type IPmult_real
  (const coordinate_type, const real);
extern bool IPequal (const coordinate_type, const coordinate_type);

#endif 

