//******************************************************************************//
// Permet de transformer un fichier tiff en un fichier raw                      //
// Ce programme fonctionne exclusivement avec les tiffs en codes binaire        //
// Compilation: gcc tiff2raw.c -ltiff -lm                                       //
// Usage: a.out <entree.tif> <resultat.ima>                                     //
// Il cree aussi un fichier appelle resultat.h notifiant la taille de l'image   //
//////////////////////////////////////////////////////////////////////////////////


#include "tiffio.h"
#include <stdio.h>
#include <string.h>

main(int argc, char* argv[])
{
  
  TIFF* tif;
  
  if(argc<3){
    fprintf(stderr,"Usage: a.out <file.tif> <file.ima> \n");
    exit(0);
  }

  tif = TIFFOpen(argv[1], "r");  // Renvoie lui meme son message d'erreur.
  
  if (tif) {
    uint32 imagelength;
    tdata_t buf;
    uint32 row,w,h;
    FILE *fp,*head;
    char nom_head[30];
    
        
    if( (fp=fopen(argv[2],"wb+")) == NULL ){
      fprintf(stderr,"\nImpossible d`acceder au fichier %s\n\n", argv[2]);
      exit(0);
    }
    
    strcpy(nom_head,argv[2]);
    strcpy(strrchr(nom_head,'.'),".h");

    
    if( (head=fopen(nom_head,"wb+")) == NULL ){
      fprintf(stderr,"\nImpossible d'acceder au fichier %s\n\n", nom_head);
      exit(0);
    }
    
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &imagelength);
    TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &w);
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &h);
    
    buf = _TIFFmalloc(TIFFScanlineSize(tif));
    
    for (row = 0; row < imagelength; row++){
      TIFFReadScanline(tif, buf, row,0);
      fwrite((unsigned char *)buf,1,TIFFScanlineSize(tif),fp);
    }
    
    
    printf("W: %d H: %d\n",w,h);   
    fprintf(head,"#taille de l'image: largeur hauteur\n%d %d",w,h);
    
    if((fclose(fp))!=0){
      fprintf(stderr,"\nImpossible de fermer le fichier : %s\n\n", argv[2]);
      exit(0);
    }
    if((fclose(head))!=0){
      fprintf(stderr,"\nImpossible de fermer le fichier : %s\n\n", nom_head);
      exit(0);
    }
    _TIFFfree(buf);
    TIFFClose(tif);
    
  }
}
